using System;
using System.Runtime.Serialization;
using System.Xml;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationTPAR2021
{
    /// <summary>
    /// TPAR
    /// </summary>
    [DataContract(Name = "TPAR", Namespace = "http://www.sbr.gov.au/ato/tpar")]
    public class TPAR
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public INT INT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 2)]
        public RP RP { get; set; }
    }

    /// <summary>
    /// Supplier Business Address
    /// </summary>
    [DataContract(Name = "AddressDetailsBusiness", Namespace = "http://www.sbr.gov.au/ato/tpar")]
    public class AddressDetailsBusiness
    {

        /// <summary>
        /// Supplier Street Address Overseas Address Indicator
        /// </summary>
        [DataMember(Order = 1)]
        public bool OverseasAddressI { get; set; }

        /// <summary>
        /// Supplier Street Address Line 1
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string Line1T { get; set; }

        /// <summary>
        /// Supplier Street Address Line 2
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string Line2T { get; set; }

        /// <summary>
        /// Supplier Street Address, Suburb, Town or Locality
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string LocalityNameT { get; set; }

        /// <summary>
        /// Supplier Street Address Postcode
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string PostcodeT { get; set; }

        /// <summary>
        /// Supplier Street Address State Or Territory
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string StateOrTerritoryC { get; set; }

        /// <summary>
        /// Supplier Street Address Country Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string CountryC { get; set; }
    }

    /// <summary>
    /// Supplier Postal Address
    /// </summary>
    [DataContract(Name = "AddressDetailsPostal", Namespace = "http://www.sbr.gov.au/ato/tpar")]
    public class AddressDetailsPostal
    {

        /// <summary>
        /// Supplier Postal Address Overseas Address Indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool OverseasAddressI { get; set; }

        /// <summary>
        /// Supplier Postal Address Line 1
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string Line1T { get; set; }

        /// <summary>
        /// Supplier Postal Address Line 2
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string Line2T { get; set; }

        /// <summary>
        /// Supplier Postal Address Suburb, Town or Locality
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string LocalityNameT { get; set; }

        /// <summary>
        /// Supplier Postal Address Postcode
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string PostcodeT { get; set; }

        /// <summary>
        /// Supplier Postal Address State Or Territory
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string StateOrTerritoryC { get; set; }

        /// <summary>
        /// Supplier Postal Address Country Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string CountryC { get; set; }
    }

    /// <summary>
    /// Supplier Declaration
    /// </summary>
    [DataContract(Name = "Declaration", Namespace = "http://www.sbr.gov.au/ato/tpar")]
    public class Declaration
    {

        /// <summary>
        /// Supplier Declaration Statement Accepted Indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool StatementAcceptedI { get; set; }

        /// <summary>
        /// Supplier Declaration Signature Date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public DateTime SignatureD { get; set; }

        /// <summary>
        /// Supplier Declaration Signatory Identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string SignatoryIdentifierT { get; set; }
    }

    /// <summary>
    /// Intermediary
    /// </summary>
    [DataContract(Name = "INT", Namespace = "http://www.sbr.gov.au/ato/tpar")]
    public class INT
    {

        /// <summary>
        /// Supplier ABN
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Tax Agent Number or Registered Agent Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxAgentNumberId { get; set; }

        /// <summary>
        /// Supplier Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string OrganisationNameDetailsOrganisationalNameT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 4)]
        public ElectronicContactTelephone ElectronicContactTelephone { get; set; }

        /// <summary>
        /// Supplier Contact Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string PersonUnstructuredNameFullNameT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 6)]
        public ElectronicContactFacsimile ElectronicContactFacsimile { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 7)]
        public AddressDetailsBusiness AddressDetailsBusiness { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 8)]
        public AddressDetailsPostal AddressDetailsPostal { get; set; }

        /// <summary>
        /// Supplier Email Address
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public string ElectronicContactElectronicMailAddressT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 10)]
        public Declaration Declaration { get; set; }
    }

    /// <summary>
    /// Payer Business or Postal Address
    /// </summary>
    [DataContract(Name = "AddressDetails", Namespace = "http://www.sbr.gov.au/ato/tpar")]
    public class AddressDetails
    {

        /// <summary>
        /// Payer Address Overseas Indicator
        /// </summary>
        [DataMember(Order = 1)]
        public bool OverseasAddressI { get; set; }

        /// <summary>
        /// Payer Address Line 1
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string Line1T { get; set; }

        /// <summary>
        /// Payer Address Line 2
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string Line2T { get; set; }

        /// <summary>
        /// Payer Address Locality Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string LocalityNameT { get; set; }

        /// <summary>
        /// Payer Address Postcode
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string PostcodeT { get; set; }

        /// <summary>
        /// Payer Address State Or Territory
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string StateOrTerritoryC { get; set; }

        /// <summary>
        /// Payer Address Country Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string CountryC { get; set; }
    }

    /// <summary>
    /// Payer Contact Telephone Number
    /// </summary>
    [DataContract(Name = "ElectronicContactTelephone", Namespace = "http://www.sbr.gov.au/ato/tpar")]
    public class ElectronicContactTelephone
    {

        /// <summary>
        /// Payer Contact Telephone Number Area Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AreaC { get; set; }

        /// <summary>
        /// Payer Contact Telephone Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string MinimalN { get; set; }
    }

    /// <summary>
    /// Payer Contact Facsimilie Number
    /// </summary>
    [DataContract(Name = "ElectronicContactFacsimile", Namespace = "http://www.sbr.gov.au/ato/tpar")]
    public class ElectronicContactFacsimile
    {

        /// <summary>
        /// Payer Contact Facsimilie Area Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AreaC { get; set; }

        /// <summary>
        /// Payer Contact Facsimilie Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string MinimalN { get; set; }
    }

    /// <summary>
    /// Reporting Party
    /// </summary>
    [DataContract(Name = "RP", Namespace = "http://www.sbr.gov.au/ato/tpar")]
    public class RP
    {

        /// <summary>
        /// Payer ABN
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Payer Branch Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string OrganisationDetailsOrganisationBranchC { get; set; }

        /// <summary>
        /// Period start date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public DateTime PeriodStartD { get; set; }

        /// <summary>
        /// Period end date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public DateTime PeriodEndD { get; set; }

        /// <summary>
        /// Financial Year
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public int TargetFinancialY { get; set; }

        /// <summary>
        /// Payer Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string OrganisationNameDetailsMainOrganisationalNameT { get; set; }

        /// <summary>
        /// Payer Trading Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string OrganisationNameDetailsTradingOrganisationalNameT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 8)]
        public AddressDetails AddressDetails { get; set; }

        /// <summary>
        /// Payer Contact Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public string PersonUnstructuredNameFullNameT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 10)]
        public ElectronicContactTelephone ElectronicContactTelephone { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 11)]
        public ElectronicContactFacsimile ElectronicContactFacsimile { get; set; }

        /// <summary>
        /// Payer Electronic Mail Address
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 12)]
        public string ElectronicContactElectronicMailAddressT { get; set; }
    }
}

