using System;
using System.Runtime.Serialization;
using System.Xml;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationTPARPYE2021
{
    /// <summary>
    /// TPARPYE
    /// </summary>
    [DataContract(Name = "TPARPYE", Namespace = "http://www.sbr.gov.au/ato/tparpye")]
    public class TPARPYE
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public Payee Payee { get; set; }
    }

    /// <summary>
    /// Payee Individual Name
    /// </summary>
    [DataContract(Name = "PersonNameDetails", Namespace = "http://www.sbr.gov.au/ato/tparpye")]
    public class PersonNameDetails
    {

        /// <summary>
        /// Payee Surname or Family Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string FamilyNameT { get; set; }

        /// <summary>
        /// Payee Given Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string GivenNameT { get; set; }

        /// <summary>
        /// Payee Other Given Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string OtherGivenNameT { get; set; }
    }

    /// <summary>
    /// Payee Business or Postal Address
    /// </summary>
    [DataContract(Name = "AddressDetails", Namespace = "http://www.sbr.gov.au/ato/tparpye")]
    public class AddressDetails
    {

        /// <summary>
        /// Payee Address Overseas Address Indicator
        /// </summary>
        //    [DataMember(EmitDefaultValue = false, Order = 1)]
        [DataMember(Order = 1)]
        public bool OverseasAddressI { get; set; }

        /// <summary>
        /// Payee Address Line 1
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string Line1T { get; set; }

        /// <summary>
        /// Payee Address Line 2
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string Line2T { get; set; }

        /// <summary>
        /// Payee Address Locality Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string LocalityNameT { get; set; }

        /// <summary>
        /// Payee Address Postcode
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string PostcodeT { get; set; }

        /// <summary>
        /// Payee Address State Or Territory
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string StateOrTerritoryC { get; set; }

        /// <summary>
        /// Payee Address Country Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string CountryC { get; set; }
    }

    /// <summary>
    /// Payee Contact Telephone Number
    /// </summary>
    [DataContract(Name = "ElectronicContactTelephone", Namespace = "http://www.sbr.gov.au/ato/tparpye")]
    public class ElectronicContactTelephone
    {

        /// <summary>
        /// Payee Contact Telephone Number Area Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AreaC { get; set; }

        /// <summary>
        /// Payee Contact Telephone Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string MinimalN { get; set; }
    }

    /// <summary>
    /// Payee
    /// </summary>
    [DataContract(Name = "Payee", Namespace = "http://www.sbr.gov.au/ato/tparpye")]
    public class Payee
    {

        /// <summary>
        /// Payee Australian Business Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Payee Financial Institution BSB
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string FinancialInstitutionAccountBankStateBranchN { get; set; }

        /// <summary>
        /// Payee Financial Institution Account Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string FinancialInstitutionAccountFinancialInstitutionAccountN { get; set; }

        /// <summary>
        /// Gross Amount Paid
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? IncomeBusinessPaymentGrossA { get; set; }

        /// <summary>
        /// Total Tax Withheld Where ABN Not Quoted
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public decimal? IncomeTaxPayAsYouGoWithholdingTaxWithheldA { get; set; }

        /// <summary>
        /// Total GST
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? GoodsAndServicesTaxLiabilityA { get; set; }

        /// <summary>
        /// Name of grant/program
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string GovernmentFundingGrantProgramNameT { get; set; }

        /// <summary>
        /// Date of payment
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public DateTime? GovernmentFundingGrantPaymentD { get; set; }

        /// <summary>
        /// Statement by a Supplier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public bool IncomeTaxPayAsYouGoWithholdingABNNotProvidedStatementI { get; set; }

        /// <summary>
        /// Payment Type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public string IncomeTaxPaymentTypeC { get; set; }

        /// <summary>
        /// Is this payment an amount listed or described under a provision of Division 59 of the ITAA 1997?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 11)]
        public string GovernmentFundingITAADivision59IndicatorC { get; set; }

        /// <summary>
        /// Amendment Indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 12)]
        public bool AmendmentI { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 13)]
        public PersonNameDetails PersonNameDetails { get; set; }

        /// <summary>
        /// Payee Non-Individual Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 14)]
        public string OrganisationNameDetailsMainOrganisationalNameT { get; set; }

        /// <summary>
        /// Payee Trading Name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 15)]
        public string OrganisationNameDetailsTradingOrganisationalNameT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 16)]
        public AddressDetails AddressDetails { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 17)]
        public ElectronicContactTelephone ElectronicContactTelephone { get; set; }
    }
}
 
